import min from"./min.js";// Verify that the optimum solution has been reached.
const verifyOptimum=({nvertex:a,edges:c,maxCardinality:d,nedge:e,blossomparent:f,mate:g,endpoint:h,dualvar:l,blossombase:m,blossomendps:n})=>{let o,p,q,r,t,u,w,y,z;// Vertices may have negative dual when maxCardinality = true;
// find a constant non-negative number to add to all vertex duals.
d?Math.max(0,-min(l,0,a)):0;// 0. all dual variables are non-negative
// 0. all edges have non-negative slack and
// 1. all matched edges have zero slack;
for(u=0;u<e;++u){for(o=c[u][0],p=c[u][1],q=c[u][2],w=l[o]+l[p]-2*q,y=[o],z=[p];-1!==f[y[y.length-1]];)y.push(f[y[y.length-1]]);for(;-1!==f[z[z.length-1]];)z.push(f[z[z.length-1]]);y.reverse(),z.reverse();const a=Math.min(y.length,z.length);for(let b=0;b<a;++b){const a=y[b],c=z[b];if(a!==c)break;w+=2*l[a]}Math.floor(g[o]/2)!==u&&Math.floor(g[p]/2)!==u}// 2. all single vertices have zero dual value;
for(r=0;r<a;++r);// 3. all blossoms with positive dual value are full.
for(t=a;t<2*a;++t)if(0<=m[t]&&0<l[t])for(o=1;o<n[t].length;o+=2)n[t][o];// Ok.
};export default verifyOptimum;
//# sourceMappingURL=verifyOptimum.js.map